#!/bin/bash
# Chromen Flash-korjausskripti
# Versio 1.0.1
# © 2014, Riku Eskelinen/ itQ.fi
# EI TAKUUTA. SUORITAT SKRIPTIN OMALLA VASTUULLASI.


LANG=C

EXPECTED_CHROME_VERSION="38.0.2125.101-1"

OLDCHROME_URL_32BIT="http://mirror.pcbeta.com/google/chrome/deb/pool/main/g/google-chrome-stable/google-chrome-stable_36.0.1985.143-1_i386.deb"
OLDCHROME_URL_64BIT="http://mirror.pcbeta.com/google/chrome/deb/pool/main/g/google-chrome-stable/google-chrome-stable_36.0.1985.143-1_amd64.deb"

echo ""
echo "Chromen Flash-korjausskripti v. 1.0.1"
echo "© 2014, Riku Eskelinen/ itQ.fi"
echo "EI TAKUUTA. SUORITAT SKRIPTION OMALLA VASTUULLASI."
echo "TUTUSTU OHJEISIIN: <http://www.itq.fi/2014/09/flash-kuntoon-wheezy-chromeen.html>"
echo ""

currentVersion=$(dpkg-query --show --showformat="\${Version}" google-chrome-stable)
if [[ "$currentVersion" ==  $EXPECTED_CHROME_VERSION || "$1" == "--force" ]]; then
  echo "Löydettiin viallisen Flash-liitännäisen sisältävä Chrome-versio ($currentVersion)."
  echo "Mitä tehdään:"
  echo " [1] Siirry vanhempaan versioon, käytä väliaikaista käyttäjäprofiilia." 
  echo " [2] Siirry vanhempaan versioon, käytä nykyistä käyttäjäprofiilia."
  echo " [3] Keskeytä."
  echo -n ">"
  read action
  if [ "$action" == "1" ]; then
    mvProfile=1
  elif [ "$action" == "2" ]; then
    mvProfile=2
  else
    echo "Keskeytä."
    exit 1
  fi
else
  echo "Löydetty Chrome-versio ei ollut se, jonka sen odotettiin olevan. Oletko varma, että ..."
  echo "  ... et ole jo suorittanut tätä skriptiä?"
  echo "  ... nyt asennetun Chrome-version Flash ($currentVersion) ei toimi?"
  echo "Jos haluat varmasti suorittaa skriptin, komenna: $0 --force"
  exit 2
fi

# Ok, nyt voidaan hyvillä mielin jatkaa

arch=$(dpkg --print-architecture)
url=""
if [ "$arch" == "amd64" ]; then
  url=$OLDCHROME_URL_64BIT
elif [ "$arch" == "i386" ]; then
  url=$OLDCHROME_URL_32BIT
else
  echo "Tuntematon arkkitehtuuri $arch. En pysty jatkamaan."
  exit 3
fi

echo "Ladataan Chrome osoitteesta $url, odota..."
wget "$url" -O /tmp/chrome.deb
if [ $? -ne 0 ]; then
  echo "Latauksessa meni jotain pieleen. Seis."
  exit 4
fi

if [ $mvProfile -eq 1 ]; then
  echo "Profiilin siirto..."
  killall chrome
  sleep 5
  # Siirrä nykyinen chrome-asetuskansio pois:
  mv ~/.config/google-chrome ~/.config/google-chrome.save
  if [ $? -ne 0 ]; then
    echo "Virhe siirrettäessä profiilia. Seis."
    exit 5
  fi
  echo "Profiili siirretty onnistuneesti. Jatketaan."
fi

# Nyt asennetaan paketti:
sudo dpkg -i /tmp/chrome.deb
if [ $? -ne 0 ]; then
  "Tapahtui virhe asennettaessa. Katso lisätietoja yläpuolelta."
  exit 6
fi

echo -n "Asennus onnistui. "
if [ $mvProfile -eq 1 ]; then
  echo "Kun Chrome on päivittynyt toimivaan versioon, voit palauttaa profiilisi suorittamalla"
  echo "restoreprofile.sh -skriptin."
else
  echo ""
fi

exit 0
